﻿using System;
using System.Windows.Data;
using Infragistics.Windows.Editors;

namespace Scrolling
{
    public class ComboBoxDataItemConverter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            Option option = value as Option;
            if (option != null)
            {
                return new ComboBoxDataItem(option, option.Value);
            }
            else
            {
                return null;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            ComboBoxDataItem comboBoxDataItem = value as ComboBoxDataItem;
            if (comboBoxDataItem != null)
            {
                return comboBoxDataItem.Value;
            }
            else
            {
                return null;
            }
        }

        #endregion
    }
}
