﻿using System;
using System.Windows.Data;
using Infragistics.Windows.Editors;

namespace Scrolling
{
    public class ComboBoxDataItemMultiConverter : IMultiValueConverter
    {

        #region IValueConverter Members

        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            Option option = values[0] as Option;
            XamComboEditor xamComboEditor = values[1] as XamComboEditor;
            if (option != null && xamComboEditor != null)
            {
                if (xamComboEditor.ItemsProvider != null)
                {
                    foreach (ComboBoxDataItem item in xamComboEditor.ItemsProvider.Items)
                    {
                        if (item.Value == option)
                        {
                            return item;
                        }
                    }
                } 
            }
            return null;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            ComboBoxDataItem item = value as ComboBoxDataItem;
            if (item != null)
            {
                object[] result = new object[1];
                result[0] = item.Value;
                return result;
            }
            return null;
        }

        #endregion
    }
}
